<template>
  <AppAbstractPage :breadcrumbs="breadcrumbs">
    <div
      slot="heading"
      class="pageHeading">
      <h1 class="heading _h1">
        Диски {{ title }}
      </h1>
    </div>

    <div
      slot="content"
      class="wheelsTyres _tyres">
      <div class="wheelsTyres-filters">
        <div class="wheelsTyres-toggle">
          <ul class="wheelsTyresToggle">
            <li class="wheelsTyresToggle-tab">
              <flink
                href="/tyres"
                class="wheelsTyresToggle-name">
                <span class="valueIsDesktop">Подобрать шины</span>
                <span class="valueIsMobile">Шины</span>
                <!-- <span class="counter">111</span> -->
              </flink>

            </li>
            <li class="wheelsTyresToggle-tab -active">
              <div class="wheelsTyresToggle-name">
                <span class="valueIsDesktop">Подобрать диски</span>
                <span class="valueIsMobile">Диски</span>
                <!-- <span class="counter">111</span> -->
              </div>
            </li>
          </ul>
        </div>
        <button
          class="buttonOnlyMobile"
          @click="changeDisplay($options.displayStates.FILTERS)">
          <!--todo - показывать заголовок со счетчиком фильтов, когда выбраны фильтры-->
          <span>
            Фильтры
            <template v-if="filtersGroup === $options.filtersGroups.PARAMS">по параметрам</template>
            <template v-if="filtersGroup === $options.filtersGroups.AUTO">по автомобилю</template>
            <span
              v-if="countSelectedFilters"
              class="counter">{{ countSelectedFilters }}</span>
          </span>
          <img
            svg-inline
            src="~/assets/svg/redesign/button-arrow-right.svg">
        </button>
        <div class="boxFilters">
          <WheelsFilters
            v-model="filtersModel"
            :scrollable="filtersMobileScrollable"
            :values="filtersValues"
            :group="filtersGroup"
            @group-change="changeFilterGroup($event); resetFilters();"
            @hide="changeDisplay($options.displayStates.LIST)"
            @reset="resetFilters"
            class="__box-gray"
            :class="{ '-open-in-mobile': display === $options.displayStates.FILTERS }"/>
        </div>
      </div>

      <div class="wheelsTyres-marks">
        <template v-if="tags && tags.length">
          <button
            class="buttonOnlyMobile"
            @click="changeDisplay($options.displayStates.POPULAR)">
            <span>Популярные шины</span>
            <img
              svg-inline
              src="~/assets/svg/redesign/arrow-left-bold.svg">
          </button>
          <div class="boxMarks">
            <div class="boxMarks-title">Популярное</div>
            <ul class="boxMarks-list">
              <li
                v-for="tag in tags"
                :key="`mark-${tag.href}`"
                class="boxMarks-item">
                <flink
                  :href="tag.href"
                  @click.native="changeDisplay($options.displayStates.LIST)"
                  class="link linkLight">
                  {{ tag.label }}
                </flink>
              </li>
            </ul>
          </div>
        </template>
      </div>

      <div
        v-if="count"
        class="wheelsTyres-warning">
        <div class="row">
          <div class="heading _h2">
            {{ count | transChoose(['Найден', 'Найдено', 'Найдено']) }}
            {{ count | spacifyNumber }}
            {{ count | transChoose(['вариант', 'варианта', 'вариантов']) }}
          </div>
        </div>
      </div>

      <div class="wheelsTyres-table">
        <header class="wheelsTyres-table-header">
          <SelectSorting
            :options="sorting"
            slot="btn-sorting"
            @order-change="onOrderChange"/>
        </header>

        <AppTable
          class="tableWheelsTyres"
          :table-headings="$options.headings"
          :grid="grid"
          :has-lazy-load="lazyLoadEnabled"
          @load-data="showMore"
          @order-change="onOrderChange">
          <!-- Ячейки с данными для таблицы -->

          <template
            :slot="`unit-${$options.headings[0].name}`"
            slot-scope="{ part }">
            <div class="picture">
              <img
                v-if="isItemHasImage(part)"
                :src="getItemImage(part)"
                :alt="getItemImageAlt(part)">
              <img
                v-else
                svg-inline
                src="~/assets/svg/redesign/navigation-parts.svg">
            </div>
          </template>

          <template
            :slot="`unit-${$options.headings[1].name}`"
            slot-scope="{ part }">
            {{ part.part_manufacturer_brand }}
          </template>

          <template
            :slot="`unit-${$options.headings[2].name}`"
            slot-scope="{ part }">
            {{ part.model_name }}
          </template>

          <template
            :slot="`unit-${$options.headings[3].name}`"
            slot-scope="{ part }">
            {{ part.width }}x{{ part.diameter }}"
            {{ part.drill }}
            ET{{ part.offset }}
            {{ part.center_diameter }}
          </template>

          <template
            :slot="`unit-${$options.headings[4].name}`"
            slot-scope="{ part }">
            {{ part.type }}
          </template>

          <template
            :slot="`unit-${$options.headings[5].name}`"
            slot-scope="{ part }">
            <span class="__no-wrap">от {{ part.min_price | spacifyNumber }} ₽</span>
          </template>

          <template
            :slot="`unit-${$options.headings[6].name}`"
            slot-scope="{ part }">
            <flink
              :href="getItemHref(part)"
              target="_blank"
              class="button linkAsButton">
              Показать
            </flink>
          </template>
        </AppTable>
      </div>
    </div>
  </AppAbstractPage>
</template>

<script>
import {
  isEmpty,
  find,
  mapValues,
  map,
  pickBy,
} from 'lodash-es';

import AppAbstractPage from '~/components/redesign/layout/app-abstract-page';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppModal from '~/components/redesign/app-modals/app-modal';
import AppCitySearch from '~/components/redesign/app-input/app-city-search';
import AppInputComposite from '~/components/redesign/app-input/app-input-composite';
import AppInputPhone from '~/components/redesign/app-input/app-input-phone';
import AppCheckbox from '~/components/redesign/app-input/app-checkbox';
import WheelsFilters from '~/components/redesign/filter-groups/wheels-filters';
import SelectSorting from '~/components/redesign/app-select/select-sorting';
import AppTable from '~/components/redesign/app-table/app-table';

import mapFilters from '~/assets/js/helpers/map-filters';
import { Wheels as Headings } from '~/assets/js/mocks/table/headings';
import RouteParamsPrefixMapping from '~/assets/js/model/wheels/route-params-prefixes';
import InitialFiltersModel from '~/assets/js/model/wheels/initial-filters-model';
import TyresWheelsMixin from '~/assets/js/mixins/redesign/tyres-wheels';
import SeoBaseMixin from '~/assets/js/mixins/seo/base';
import SeoMixin from '~/assets/js/mixins/seo/pages/main/wheels';

const apiUrls = Object.freeze({
  data: '/_main/wheelItem/list',
  filters: '/_main/wheelItem/filters',
  count: '/_main/wheelItem/count',
});

export default {
  name: 'Wheels',
  components: {
    AppAbstractPage,
    AppButton,
    AppModal,
    AppCitySearch,
    AppInputComposite,
    AppInputPhone,
    AppCheckbox,
    WheelsFilters,
    SelectSorting,
    AppTable,
  },
  mixins: [TyresWheelsMixin('wheels', apiUrls), SeoBaseMixin, SeoMixin],
  scrollToTop: false,
  async asyncData({ app, params, error }) {
    const limit = 12;
    const order = {
      field: 'min_price',
      direction: 'asc',
    };
    const filtersModel = { ...InitialFiltersModel };

    const apiCriteria = Object.keys(params)
      .filter(key => params[key])
      .reduce((result, key) => {
        result[key] = params[key].substring(RouteParamsPrefixMapping[key].length + 1);
        return result;
      }, {});
    const apiRequestParams = {
      criteria: apiCriteria,
      limit: isEmpty(apiCriteria) ? 0 : limit,
      order,
    };

    try {
      const [
        { data },
        { data: filtersValues },
        { data: count },
      ] = await Promise.all([
        app.$axios.$get(apiUrls.data, { params: apiRequestParams }).catch(e => console.error(e)),
        app.$axios.$get(apiUrls.filters, { params: apiRequestParams }).catch(e => console.error(e)),
        !isEmpty(apiCriteria)
          ? app.$axios.$get(apiUrls.count, { params: apiRequestParams }).catch(e => console.error(e))
          : Promise.resolve({ data: null }),
      ]);

      Object.keys(params).forEach((key) => {
        if (!params[key]) {
          return;
        }

        const value = params[key].substring(RouteParamsPrefixMapping[key].length + 1);
        const model = find(filtersValues[key], o => String(o.id) === String(value));
        if (!model) {
          error({ statusCode: 404 });
          return;
        }
        filtersModel[key] = model;
      });

      return {
        data,
        filtersValues: mapValues(filtersValues, filter => (Array.isArray(filter) ? filter : [])),
        filtersModel,
        tagsOrigins: [],
        count: count || 0,
        limit,
        order,
      };
    } catch (e) {
      console.error(e);
      error({ statusCode: 500 });
      return {};
    }
  },
  computed: {
    title() {
      return map(
        pickBy(this.filtersModel, item => item !== null),
        (item, key) => {
          let piece = this.filtersModel[key].name;

          switch (key) {
            case 'offset': piece = `ET${piece}`; break;
            case 'diameter': piece = `R${piece}`; break;
            case 'width': piece = `шириной ${piece}″`; break;
            case 'centerDiameter': piece = `DIA${piece}`; break;
            case 'type':
              switch (piece) {
                case 'Литой': piece = 'литые'; break;
                case 'Литой легкосплавный': piece = 'литые легкосплавные'; break;
                case 'Штампованный': piece = 'штампованные'; break;
                default: piece = '';
              }
              break;
            default: piece = '';
          }

          return piece;
        },
      ).filter(Boolean).join(' ');
    },
    breadcrumbs() {
      const breadcrumbs = [
        {
          name: 'Диски',
          url: '/wheels',
        },
      ];
      if (this.title) {
        breadcrumbs.push({
          name: `Диски ${this.title}`,
          url: '',
        });
      }
      breadcrumbs[breadcrumbs.length - 1].url = '';
      return breadcrumbs;
    },
  },
  created() {
    this.$options.headings = Headings;
    this.$options.InitialFiltersModel = InitialFiltersModel;
    this.$options.RouteParamsPrefixMapping = RouteParamsPrefixMapping;
  },
  methods: {
    ...mapFilters(['brandSlug', 'vendorCodeSlug']),
    // TODO: Нужна проверка на то что значение корректны
    getItemHref(item) {
      const url = ['/poisk-po-nomeru'];
      url.push(this.brandSlug(item.part_manufacturer_brand));
      url.push(this.vendorCodeSlug(item.vendor_code));
      return url.join('/');
    },
    isItemHasImage(item) {
      return Boolean(item.part_image_id);
    },
    getItemImage(item) {
      const url = ['/files/part-image'];
      url.push(item.part_image_id);
      url.push('medium');
      url.push(`${item.part_image_id}.jpg`);
      return url.join('/');
    },
    getItemImageAlt(item) {
      return [
        item.model_name,
        item.part_manufacturer_brand,
        item.type,
        `${item.width}x${item.diameter}`,
        item.diameter,
        item.drill,
        `ET${item.offset}`,
        `DIA${item.center_diameter}`,
      ].join(' ').replace(/[^a-zA-Zа-яА-ЯёЁ0-9 .]/g, '');
    },
  },
};
</script>

<style lang="postcss">
  /*Стили для страниц Шины + Диски*/
  @import "~/assets/css/components/wheels-tyres-pages.css";
</style>
